var TIME_SPLASH = 1000;
var COLORES = [
    "#FC4CCB",
    "#00FFB0",
    "#5F37A5",
    "#E9C0FF",
    "#FFCF37",
    "#FF5950",
    "#00FFFF",
    "#FFFF00"
];
const PLATFORM_VIMEO = 'vimeo';
const PLATFORM_YOUTUBE = 'youtube';
var intervalId, SERIES = 0, IMAGENES_CARGADAS = 0;
var deviceType = (navigator.userAgent.match(/iPad/i)) == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i)) == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
var historial = { "actual": false, "anterior": null, "splash": false, "home": false, "categorias": false, "item": false, "video-section": false, "busqueda": null };
var ids = { "home": "estrenos", "categorias": null, "item": [], "item_actual": null, "item_proximo": null, "item_proximo_un3_id": null, "video": null, "video-anterior": null, "busqueda": null };
var nombre_item = null; var player; var video_stop = false; var myScroll = {}; var salir = false; var vimeo_player;
//--------------------------------------PRESPLASHSCREEN-----------------------------------------------
$(document).on('pagebeforeshow', "#presplash", function (event, data) {
    irA('#splash', 'fade');
    event.preventDefault();
});
//--------------------------------------SPLASHSCREEN-----------------------------------------------
$(document).on('pagebeforeshow', "#splash", function (event, data) {
    historial["actual"] = "#splash";
    historial["splash"] = true;
    try { screen.lockOrientation("portrait"); } catch (e) { }
    if (deviceType != "Android") {
        $('div[data-role="header"], #categorias-link').css("padding-top", "20px");
        $('.ui-content').css("margin-top", "20px");
    }
    $.getJSON("https://un3.tv/rest/un3/public/categories", parseDataHome);
    window.setTimeout(function () { $('#splash #splash-spinner').show(); }, TIME_SPLASH);
});
function parseDataHome(data) {
    try {
        var i = 0;
        for (var cat in data) {
            if (cat == 'Slider') {
            } else {
                createCategories(cat, i);
                addSeries(cat, data[cat]);
                i = (i + 1) % COLORES.length;
            }
        }
        for (var cat in data) {
            $("#lista-" + getCatFormat(cat)).addClass('catSelected');
            break;
        }
    } catch (e) { alert(e); }
    $("#home-spinner").hide();
    try { $("#scroll-home").iscrollview("refresh"); } catch (e) { }
    intervalId = setInterval(function () {
        if (IMAGENES_CARGADAS >= SERIES) {
            clearInterval(intervalId);
            irA("#home", "fade");
        }
    }, 500);
}
function createCategories(cat, i) {
    var aux = getCatFormat(cat);
    $('#div-nombre').parent().append('<ul id="lista-' + aux + '"></ul>');
    $('#categorias #lista-categorias').append('<li data-id-categoria="' + aux + '" data-color="' + COLORES[i] + '"><span>' + cat + '</span><img src="img/flecha.png"></li>');
}
function addSeries(cat, data) {
    SERIES++;
    var elem = $('#lista-' + getCatFormat(cat));
    for (var i = 0; i < data.length; i++) {
        var item = data[i];
        let platform = item.youtube_o_vimeo || PLATFORM_YOUTUBE;
        let vimeo_playlist = item.playlist_vimeo || '';
        var output = '<li data-un3-id="' + item.id + '" data-id-serie="' + item.playlist + '" data-platform="' + platform + '" data-vimeo-playlist="' + vimeo_playlist + '">';
        output += '<img src="' + item.img + '" onload="imageLoaded(this);">';
        output += '<img class="imgSpinner" src="img/splash_loader.gif" style="width:50px; height:auto;">';
        output += '<div class="li-footer"><span class="nombre">' + item.name + '</span><br><span class="descripcion"></span><div class="count" style="display:none;">0</div></div>';
        output += '</li>';
        $.getJSON("https://un3.tv/rest/un3/public/shows/" + item.id, updateSerieDesc);
        elem.append(output);
    }
}
function imageLoaded(elem) {
    IMAGENES_CARGADAS++;
    $(elem).parent().find(".imgSpinner").hide();
}
function updateSerieDesc(data) {
    var output = data.cantidad + (data.cantidad == 1 ? " cap de " : " caps de ") + data.duracion + "\'";
    $('#scroll-home li[data-un3-id="' + data.id + '"] .descripcion').html(output);
    $('#lista-amigos .li-footer').hide();
}
//------------------------------------------HOME---------------------------------------------------
$(document).on('pagebeforeshow', "#home", function (event, data) {
    try { screen.lockOrientation("portrait"); } catch (e) { }
    $("#home .ui-content").css("opacity", 1);
    $('div[data-role="header"] *').show();
    $('div[data-role="header"] div').hide();
    historial["anterior"] = historial["actual"];
    historial["actual"] = "#home";
    if (!historial["home"]) {
        historial["home"] = true;
    }
    $("#lista-" + ids["home"]).show();
    $("#scroll-home").iscrollview("refresh");
});
$(document).on('tap', '#home .ui-content ul li', function (e) {
    if ($('.catSelected span').text() == "Amigos") {
        if (deviceType == "Android") {
            window.androidActivity.openPlayList("https://www.youtube.com/watch?list=" + $(this).attr("data-id-serie"));
        } else {
            window.open("https://www.youtube.com/watch?list=" + $(this).attr("data-id-serie"), "_system");
        }
    } else {
        ids["item_proximo_youtube_playlist"] = $(this).attr("data-id-serie");
        ids["item_proximo_platform"] = $(this).attr("data-platform");
        ids["item_proximo_vimeo_playlist"] = $(this).attr("data-vimeo-playlist");
        ids["item_proximo_un3_id"] = $(this).attr("data-un3-id");
        ids["item_proximo"] = $(this).attr("data-un3-id");
        nombre_item = $(this).children().find(".nombre").html();
        irA("#item", "slide");
    }
});
//---------------------------------------CATEGORIAS------------------------------------------------
$(document).on('tap', '#categorias #header-text, #categorias #categorias-atras', function () { irA("#home", "slide"); });
$(document).on('tap', '#categorias li', function () {
    $("#home #nombre-home").text($(this).children("span").text());
    var new_home = $(this).attr("data-id-categoria");
    if (new_home != ids["home"]) {
        $("#lista-" + ids["home"]).hide();
        ids["home"] = new_home;
        $("#lista-" + ids["home"]).show();
    }
    $('.catSelected').removeClass('catSelected');
    $(this).addClass('catSelected');
    $(this).css("color", $(this).attr("data-color"));
    $(this).css("background-color", "rgba(11,2,65,0.4)");
    setTimeout(function () { irA("#home", "slide"); }, 250);
});
$(document).on('pagebeforeshow', "#categorias", function () {
    try { screen.lockOrientation("portrait"); } catch (e) { }
    historial["anterior"] = historial["actual"];
    historial["actual"] = "#categorias";
    historial["categorias"] = true;
    $("#categorias li").css("color", "#ffffff");
    $("#categorias li").css("background-color", "transparent");
    $("#scroll-categorias").iscrollview("refresh");
});
$(document).on('pageload', "#categorias", function () { $("#scroll-categorias").iscrollview("refresh"); });
//------------------------------------------ITEM---------------------------------------------------
$(document).on('pagebeforeshow', "#item", function (event, data) {
    try { screen.lockOrientation("portrait"); } catch (e) { }
    $("#item .ui-content").css("opacity", 1);
    $('div[data-role="header"] *').show();
    $('div[data-role="header"] div').hide();
    historial["anterior"] = historial["actual"];
    historial["actual"] = "#item";
    historial["item"] = true;
    if (ids["item_proximo"] != ids["item_actual"]) {
        ids["item_actual"] = ids["item_proximo"];
        if (ids["item_proximo_platform"] === PLATFORM_VIMEO) {
            ids["video-anterior"] = ids["video"];
            ids["video"] = ids["item_proximo_youtube_playlist"];
        } else {
            $("#item .container").css("display", "none");
            if (ids["item_actual"] in ids["item"]) {
                $('#item div[data-id="' + id_serie + '"]').css("display", "init");
                $("#item-spinner").hide();
                $("#item #nombre-serie").html(nombre_item);
            } else {
                $("#item-spinner").show();//Mostrar spinner
                /*HACER CARGA NUEVA*/
                $.getJSON("https://www.googleapis.com/youtube/v3/playlistItems?part=snippet&playlistId=" + ids["item_proximo_youtube_playlist"] + "&maxResults=50&key=AIzaSyArw7TqkpJewv5yb304ljmJ1zT-YbJtSY8", parseItemData);
            }
        }
    }
    if (ids["item_proximo_platform"] === PLATFORM_VIMEO) {
        $("#item-spinner").hide();
        irA("#video-section", "slide");
    }
    $("#scroll-item").iscrollview("refresh");
});
function parseItemData(data) {
    var color = hexToRgb($('.catSelected').attr("data-color"));
    color = 'rgba(' + color.r + ',' + color.g + ',' + color.b + ', 0.4)';
    var output = '<div class="container" data-id="' + ids["item_actual"] + '"><div class="div-titulo">' + nombre_item + '</div><ul></ul></div>'
    $("#item #nombre-serie").html(nombre_item);
    $("#item .ui-content #item-div").append(output);
    for (var i = 0; i < data.items.length; i++) {
        var output = '<li data-id-video="' + data.items[i].snippet.resourceId.videoId + '" style="background:url(' + data.items[i].snippet.thumbnails.medium.url + ') no-repeat center; -webkit-background-size:contain;">';
        output += '<div class="indice" style="background-color:' + color + '"><span>' + (i + 1) + '</span></div></li>';
        $('#item .ui-content #item-div .container[data-id="' + ids["item_actual"] + '"] ul').append(output);
    }
    $("#item-spinner").hide();
    var nextIndex = i;
    var nextPageToken = data.nextPageToken;
    if (nextPageToken != null) { $.getJSON("https://www.googleapis.com/youtube/v3/playlistItems?part=snippet&playlistId=" + ids["item_proximo_youtube_playlist"] + "&maxResults=50&key=AIzaSyArw7TqkpJewv5yb304ljmJ1zT-YbJtSY8pageToken=" + nextPageToken, continueDataItem); }
    $("#scroll-item").iscrollview("refresh");
}
function continueDataItem(data) {
    for (var i = 0; i < data.items.length; i++) {
        var output = '<li data-id-video="' + data.items[i].snippet.resourceId.videoId + '" style="background:url(' + data.items[i].snippet.thumbnails.medium.url + ') no-repeat center; -webkit-background-size:contain;">';
        output += '<div class="indice"><span>' + nextIndex + '</span></div></li>';
        $('#item .ui-content #item-div .container[data-id="' + ids["item_actual"] + '"] ul').append(output);
        nextIndex++;
    }
    $("#scroll-item").iscrollview("refresh");
    var nextPageToken = data.nextPageToken;
    if (nextPageToken != null) { $.getJSON("https://www.googleapis.com/youtube/v3/playlistItems?part=snippet&playlistId=" + ids["item_proximo_youtube_playlist"] + "&maxResults=50&key=AIzaSyArw7TqkpJewv5yb304ljmJ1zT-YbJtSY8&pageToken=" + nextPageToken, continueDataItem); }
}
$(document).on('tap', '#item li', function () {
    ids["video-anterior"] = ids["video"];
    ids["video"] = $(this).attr("data-id-video");
    irA("#video-section", "slide");
});
//------------------------------------------VIDEO--------------------------------------------------
$(document).on('pagebeforeshow', "#video-section", function (event, data) {
    try { screen.lockOrientation("landscape"); } catch (e) { }
    historial["anterior"] = historial["actual"];
    historial["actual"] = "#video-section";
    $("#video-spinner").show();
    if (ids["item_proximo_platform"] === PLATFORM_VIMEO) {
        let width = $(window).width();
        let height = $(window).width();
        $("#video-div").empty().hide();
        $("#vimeo-container")
            .show()
            .css('margin-top','60px')
            .html('<iframe src="https://un3.tv/rest/un3/public/iframe/' + ids["item_proximo_vimeo_playlist"] + `?width=${width}&height=${height}` + '" width="' + width + '" height="' + height + '" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>');
        return;
    }
    $("#vimeo-container").hide().empty();
    $("#video-div").show();
    // ids["item_proximo_vimeo_playlist"] = $(this).attr("data-vimeo-playlist");
    // ids["item_proximo_un3_id"] = $(this).attr("data-un3-id");
    if (historial["video-section"]) {
        try {
            player.loadVideoById(ids["video"]);
        } catch (e) {
            $("#video-div").html('<iframe id="iframe" src="https://www.youtube.com/embed/' + ids["video"] + '?autoplay=1&autohide=1&modestbranding=1&rel=0&enablejsapi=1&showinfo=0" width="' + ($(window).height()) + '" height="' + $(window).width() + '" frameborder="0"  allowfullscreen></iframe>');
        }
    } else {
        historial["video-section"] = true;
        video_stop = false;
        prepareYoutubeAPI();
        $("#video-div").html('<iframe id="iframe" src="https://www.youtube.com/embed/' + ids["video"] + '?autoplay=1&autohide=1&modestbranding=1&rel=0&enablejsapi=1&showinfo=0" width="' + ($(window).height()) + '" height="' + $(window).width() + '" frameborder="0"  allowfullscreen></iframe>');
    }
    if (deviceType == "Android") {
        $("#vh").remove();
    } else {
        setTimeout(()=>{
        var elem = document.getElementById("iframe");
        if (elem.requestFullscreen) {
            elem.requestFullscreen();
        } else if (elem.msRequestFullscreen) {
            elem.msRequestFullscreen();
        } else if (elem.mozRequestFullScreen) {
            elem.mozRequestFullScreen();
        } else if (elem.webkitRequestFullscreen) {
            elem.webkitRequestFullscreen();
        }
        },0);
    }
});

// Hide spinner when iframe is loaded
window.addEventListener('message', (e)=>{
    if(e.data === 'iframeLoaded'){
        $("#video-spinner").hide();
        var iframe = document.querySelector('#vimeo-container iframe');
        // vimeo_player = new Vimeo.Player(iframe);
        var elem = iframe;
        if (elem.requestFullscreen) {
            elem.requestFullscreen();
        } else if (elem.msRequestFullscreen) {
            elem.msRequestFullscreen();
        } else if (elem.mozRequestFullScreen) {
            elem.mozRequestFullScreen();
        } else if (elem.webkitRequestFullscreen) {
            elem.webkitRequestFullscreen();
        }
    }
});

function prepareYoutubeAPI() {
    var tag = document.createElement('script');
    tag.src = "https://www.youtube.com/iframe_api";
    var firstScriptTag = document.getElementsByTagName('script')[0];
    firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);
}
function onYouTubeIframeAPIReady() {
    $("#video-spinner").hide();
    player = new YT.Player('iframe', {
        events: {
            'onReady': onPlayerReady,
            'onStateChange': onPlayerStateChange,
            'onError': onPlayerError
        }
    });
}
function onPlayerError(e) {
    $("#video-spinner").hide();
    if (e.data == 150 || e.data == 101) {
        try {
            navigator.notification.confirm(
                '¿Desea abrir el video con una app externa?',
                onConfirm,
                'Error en el reproductor.',
                ['Sí', 'No']
            );
        } catch (e) {
            var r = confirm('Error en el reproductor ¿Desea abrir el video con una app externa?');
            onConfirm((r == true ? 1 : 2));
        }
    }
}
function onConfirm(e) {
    if (e == 1) {
        if (deviceType == "Android") {
            window.open("vnd.youtube:" + ids["video"]);
        } else {
            window.open("youtube://" + ids["video"]);
        }
    } else {
        irAAtras();
    }
}
function onPlayerReady(event) {
    $("#video-spinner").hide();
    if (!video_stop) { event.target.playVideo(); }
}
function onPlayerStateChange(event) {
    $("#video-spinner").hide();
}
function stopVideo() {
    $("#video-spinner").hide();
    video_stop = true;
    if (ids["item_proximo_platform"] === PLATFORM_VIMEO) {
        try { vimeo_player.pause().then() } catch (e) { console.log("stop-video-catch - vimeo"); }
        $("#vimeo-container").empty();
        return;
    }
    try { player.stopVideo(); } catch (e) { console.log("stop-video-catch"); }
}
function pauseVideo() {
    if (ids["item_proximo_platform"] === PLATFORM_VIMEO) {
        try { vimeo_player.pause().then() } catch (e) { console.log("pause-video-catch - vimeo"); }
        $("#vimeo-container").empty();
        return;
    }
    try {
        player.pauseVideo();
    } catch (e) { console.log("stop-video-catch"); }
}
function resumeVideo() {
    if (historial["actual"] == "#video-section") {
        if (ids["item_proximo_platform"] === PLATFORM_VIMEO) {
            try { vimeo_player.play().then() } catch (e) { console.log("resume-video-catch - vimeo"); }
            return;
        }
        try {
            player.playVideo();
        } catch (e) { console.log("resume-video-catch"); }
    }
}
//---------------------------------------BUSQUEDAS-------------------------------------------------
$(document).on('tap', '#atras-after', function () {
    $(".ui-content").css("opacity", 1);
    $('div[data-role="header"] *').show();
    $('div[data-role="header"] div').hide();
    $('#input_busqueda').val(null);
});
$(document).on('tap', '#busqueda-link', function () {
    $('div[data-role="header"] *').hide();
    $('div[data-role="header"] div').show();
    $('div[data-role="header"] div *').show();
    $('#busqueda-link-after').show();
    $('#input_busqueda').show();
    $('#atras-after').show();
});
$('#home #input_busqueda, #item #input_busqueda').focus(function () {
    $("#home .ui-content, #item .ui-content").css("opacity", 0.4);
});
$(document).on("tap", '#busqueda-link-after', function () { $('#input_busqueda, #busqueda input').keypress(); });
$('#input_busqueda, #busqueda input').keypress(function (e) {
    var buscar = $(this).val();
    if ((e.isTrigger || e.which == 13) && buscar.length > 0) {
        ids["busqueda"] = buscar;
        if (historial["actual"] == "#busqueda") {
            busquedaIn();
        } else {
            irA("#busqueda", "slide");
        }
        return false;
    }
});
$(document).on('pagebeforeshow', "#busqueda", function () {
    try { screen.lockOrientation("portrait"); } catch (e) { }
    if (historial["busqueda"] == null) { historial["busqueda"] = historial["actual"]; }
    historial["anterior"] = historial["actual"];
    historial["actual"] = "#busqueda";
    busquedaIn();
});
function busquedaIn(event, data) {
    $("#busqueda #lista-busqueda").empty();
    $("#resultados-cant").html("Buscando...");
    $("#busqueda-spinner").show();
    $("#home #input_busqueda, #busqueda #input_busqueda").attr("value", ids["busqueda"]);
    $('#busqueda #categorias-link').show();
    $('#busqueda #cerrar').show();
    $("#scroll-busqueda").iscrollview("refresh");
    $.getJSON("https://www.googleapis.com/youtube/v3/search?part=snippet&channelId=UCr1oW9zCnsBgYZnBwvRPHCQ&key=AIzaSyArw7TqkpJewv5yb304ljmJ1zT-YbJtSY8&type=video,playlist&maxResults=50&q=" + ids["busqueda"], parseBusqueda);
}
function parseBusqueda(data) {
    $("#busqueda-spinner").hide();
    $("#resultados-cant").html((data.pageInfo.totalResults).toString() + " resultados encontrados.");
    var items = data.items;
    for (var i in items) {
        var auxId = (items[i].id.kind).split("#")[1];
        auxId += "#" + ((auxId == "video") ? items[i].id.videoId : ((auxId == "playlist") ? items[i].id.playlistId : null));
        var output = '<li class="item-busqueda" data-id="' + auxId + '">';
        output += '<img src="' + items[i].snippet.thumbnails.default.url + '">';
        output += '<span>' + items[i].snippet.title + '</span>';
        output += '</li>';
        $("#lista-busqueda").append(output);
    }
    var nextToken = data.nextPageToken;
    if (nextToken) {
        $.getJSON("https://www.googleapis.com/youtube/v3/search?part=snippet&channelId=UCr1oW9zCnsBgYZnBwvRPHCQ&key=AIzaSyArw7TqkpJewv5yb304ljmJ1zT-YbJtSY8&order=title&type=video,playlist&maxResults=50&pageToken=" + nextToken + "q=" + ids["busqueda"], parseBusqueda);
    }
}
$(document).on('tap', '#lista-busqueda li', function () {
    var dataId = $(this).attr("data-id");
    var tipo = dataId.split("#")[0];
    var id = dataId.split("#")[1];
    if (tipo == "playlist") {
        ids["item_proximo"] = id;
        nombre_item = $('li[data-id="' + dataId + '"] span').html();
        irA("#item", "slide");
    } else if (tipo == "video") {
        ids["video-anterior"] = ids["video"];
        ids["video"] = id;
        irA("#video-section", "slide");
    }
});
$(document).on('tap', '#busqueda #cerrar', function () {
    var aux = historial["busqueda"];
    historial["busqueda"] = null;
    irA("#home", "slide", 1);
});
//-----------------------------------------OTROS---------------------------------------------------
$(document).on('tap', '#atras-link', irAAtras);
function irAAtras() {
    switch (historial["actual"]) {
        case "#splash":
        case "#home":
            if (salir) {
                navigator.app.exitApp();
            } else {
                salir = true;
                setTimeout(function () { salir = false; }, 2500);
                if (deviceType == "Android") {
                    window.androidActivity.toast();
                }
            }
            break;
        case "#categorias":
            irA("#home", "slide");
            break;
        case "#item":
            irA(((historial["anterior"] == "#busqueda") ? "#busqueda" : "#home"), "slide", true);
            break;
        case "#video-section":
            try { screen.lockOrientation("portrait"); } catch (e) { }
            irA(((historial["anterior"] == "#busqueda") ? "#busqueda" : (ids["item_proximo_platform"] === PLATFORM_VIMEO ? "#home" : "#item")), "slide", true);
            stopVideo();
            break;
        case "#busqueda":
            $("#busqueda #cerrar").click();
            break;
    }
}
function irA(hacia, t, _reverse) {
    $(":mobile-pagecontainer").pagecontainer("change", hacia, { transition: ((t != null) ? t : "pop"), reverse: _reverse != null });
}
function onDeviceReady() { document.addEventListener("onpopstate", irAAtras, false); }
function onPauseDevice() { pauseVideo(); }
function onResumeDevice() { resumeVideo(); }
document.addEventListener("resume", onResumeDevice, false);
document.addEventListener("pause", onPauseDevice, false);
document.addEventListener("deviceready", onDeviceReady, false);
document.addEventListener("backbutton", irAAtras, false);
function replaceLatinChar(string) { return output = string.replace(/á|é|í|ó|ú|ñ|ä|ë|ï|ö|ü/ig, function (str, offset, s) { var str = str == "á" ? "a" : str == "é" ? "e" : str == "í" ? "i" : str == "ó" ? "o" : str == "ú" ? "u" : str == "ñ" ? "n" : str; str = str == "Á" ? "A" : str == "É" ? "E" : str == "Í" ? "I" : str == "Ó" ? "O" : str == "Ú" ? "U" : str == "Ñ" ? "N" : str; str = str == "Á" ? "A" : str == "É" ? "E" : str == "Í" ? "I" : str == "Ó" ? "O" : str == "Ú" ? "U" : str == "Ñ" ? "N" : str; str = str == "ä" ? "a" : str == "ë" ? "e" : str == "ï" ? "i" : str == "ö" ? "o" : str == "ü" ? "u" : str; str = str == "Ä" ? "A" : str == "Ë" ? "E" : str == "Ï" ? "I" : str == "Ö" ? "O" : str == "Ü" ? "U" : str; return (str); }) }
function hexToRgb(hex) {
    hex = hex ? hex : COLORES[0];
    var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
    hex = hex.replace(shorthandRegex, function (m, r, g, b) { return r + r + g + g + b + b; });
    var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
    return result ? { r: parseInt(result[1], 16), g: parseInt(result[2], 16), b: parseInt(result[3], 16) } : null;
}
function getCatFormat(str) {
    return ((replaceLatinChar(str)).replace(/\s/g, "")).toLowerCase();
}
